import React from 'react';
import { SortableHandle } from 'react-sortable-hoc';
import { createStyledComponent } from '@cloudflare/style-container';
import { Span } from '@cloudflare/elements';
import DragHandleIcon from './DragHandleIcon';
const Handle = createStyledComponent(({
  sorting
}) => ({
  whiteSpace: 'nowrap',
  cursor: 'grab',
  opacity: sorting ? 0.5 : 1,
  pointerEvents: sorting ? 'none' : undefined,
  transition: 'opacity 0.2s linear',
  display: 'flex',
  px: 1,
  mr: 1
}));
export default SortableHandle(({
  order,
  disabled,
  sorting
}) => /*#__PURE__*/React.createElement(Handle, {
  className: "cf-drag-handle",
  sorting: sorting
}, !disabled && /*#__PURE__*/React.createElement(Span, {
  minWidth: 10
}, /*#__PURE__*/React.createElement(DragHandleIcon, null)), order && /*#__PURE__*/React.createElement(Span, {
  ml: 2
}, order)));