function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { createStyledComponent } from '@cloudflare/style-container';
import { Div } from '@cloudflare/elements';
import { SELECTABLE_ID, EXPANDABLE_ID } from './Table';
import { Icon } from '@cloudflare/component-icon'; // A11Y-94: Button to trigger sorting for keyboard users.

const SortButton = createStyledComponent(() => ({
  background: 'none',
  color: 'inherit',
  alignItems: 'center',
  display: 'flex',
  border: 'none',
  padding: 0,
  font: 'inherit',
  cursor: 'pointer',
  outline: 'inherit',
  width: '100%',
  '&:focus': {
    outline: 'solid',
    outlineOffset: 3,
    outlineStyle: 'auto',
    outlineColor: 'gray.8'
  }
}), 'button');
const HeaderCellWrapper = createStyledComponent(({
  theme,
  isLoading,
  hasError,
  isEmpty,
  column
}) => _objectSpread({
  display: 'flex',
  alignItems: 'center',
  fontSize: 2,
  fontWeight: 600,
  color: 'gray.1',
  pl: 2,
  pr: 2,
  pb: 1,
  pt: 1,
  backgroundColor: theme.colors.background,
  borderBottom: `1px solid ${theme.colors.gray[7]}`,
  transition: 'opacity 0.2s, background-color 0.2s'
}, column.canSort ? {
  cursor: 'pointer'
} : {}, {
  '&:hover': {
    backgroundColor: column.canSort && !isLoading && !hasError && !isEmpty && theme.colors.gray[9]
  }
}), 'th');

const HeaderCell = ({
  column,
  isLoading,
  isEmpty,
  hasError,
  selectAllKey
}) => /*#__PURE__*/React.createElement(HeaderCellWrapper, _extends({}, column.getHeaderProps({
  style: _objectSpread({}, (column.id === SELECTABLE_ID || column.id === EXPANDABLE_ID) && {
    flex: '0 0 auto'
  })
}), {
  "aria-sort": column.isSorted ? column.isSortedDesc ? 'descending' : 'ascending' : 'none',
  isLoading: isLoading,
  hasError: hasError,
  isEmpty: isEmpty,
  column: column
}), column.canSort ? /*#__PURE__*/React.createElement(SortButton, {
  onClick: () => column.toggleSortBy()
}, column.render('Header', {
  selectAllKey
}), column.canSort && !isLoading && !hasError && !isEmpty && /*#__PURE__*/React.createElement(Div, {
  display: "flex",
  ml: 2,
  style: {
    transform: column.isSortedDesc ? 'rotate(-180deg)' : ''
  }
}, column.isSorted ? /*#__PURE__*/React.createElement(Icon, {
  type: "caret-up",
  color: "gray.0",
  label: ""
}) : /*#__PURE__*/React.createElement(Icon, {
  type: "reorder",
  color: "gray.0",
  label: "",
  size: 12
}))) : column.render('Header', {
  selectAllKey
}));

export default HeaderCell;