function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr && (typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]); if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? Object(arguments[i]) : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { useMemo, useEffect, useState, useRef, Fragment } from 'react';
import { useTable, useFlexLayout, useSortBy, useExpanded, useRowSelect, usePagination, useGlobalFilter } from 'react-table';
import { variables as theme } from '@cloudflare/style-const';
import { applyStaticStyles } from '@cloudflare/style-container';
import { Trans } from '@cloudflare/intl-react';
import { Div, Span } from '@cloudflare/elements';
import { Link } from '@cloudflare/component-link';
import { Icon } from '@cloudflare/component-icon';
import { Checkbox } from '@cloudflare/component-checkbox';
import { Pagination } from '@cloudflare/component-pagination';
import { SortableContainer, SortableElement, arrayMove } from 'react-sortable-hoc';
import DragHandle from './DragHandle';
import MoveRowButtons from './MoveRowButtons';
import { List, AutoSizer, CellMeasurer, CellMeasurerCache } from 'react-virtualized';
import useMeasure from 'react-use-measure';
import { ResizeObserver as ResizeObserverPolyfill } from '@juggle/resize-observer';
const ResizeObserver = window.ResizeObserver || ResizeObserverPolyfill;
import { DefaultCell } from './CellStyles';
import HeaderRow from './HeaderRow';
import Row from './Row';
const SortableList = SortableContainer(List);
const SortableRow = SortableElement(Row);
const borderColor = theme.colors.gray[7];
export const EXPANDABLE_ID = 'expandable-id';
export const SELECTABLE_ID = 'selectable-id';
export const DRAGGABLE_ID = 'draggable-id';
const defaultScrollHeight = 700;
let count = 0;
const ScrollWrapper = applyStaticStyles(`
  .ReactVirtualized__List {
    outline: none
  }
  .cf-table-row-drag {
    pointer-events: auto !important;
    z-index: 2000 !important;
    box-shadow: 0 0 10px rgba(0, 0, 0, 0.2) !important;
    background-color: ${theme.colors.background} !important;
  }
  .cf-table-row-drag * {
    cursor: grabbing !important;
  }
  `, Div);
export const isRowActions = columnId => [EXPANDABLE_ID, SELECTABLE_ID, DRAGGABLE_ID].includes(columnId);
const draggableColumn = {
  id: DRAGGABLE_ID,
  width: 50,
  Cell: ({
    row,
    rows,
    column,
    columns,
    allColumns
  }) => {
    var _ref, _row$getRowProps, _column$isDragHandleV;

    const rowId = `table_${column.getTableId()}_row${((_ref = row.original) === null || _ref === void 0 ? void 0 : _ref.id) || ((_row$getRowProps = row.getRowProps()) === null || _row$getRowProps === void 0 ? void 0 : _row$getRowProps.key)}`;
    const indexOffset = allColumns.length - columns.length;
    return /*#__PURE__*/React.createElement(DefaultCell, {
      px: 2,
      justifyContent: "center"
    }, ((_column$isDragHandleV = column.isDragHandleVisible) === null || _column$isDragHandleV === void 0 ? void 0 : _column$isDragHandleV.call(column)) && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(DragHandle, null), /*#__PURE__*/React.createElement(MoveRowButtons, {
      handleMoveUpClick: row.index > 0 ? () => column.moveRow(rows, {
        oldIndex: row.index,
        newIndex: row.index - 1
      }) : undefined,
      handleMoveDownClick: row.index < rows.length - 1 ? () => {
        column.moveRow(rows, {
          oldIndex: row.index,
          newIndex: row.index + 1
        });
      } : undefined,
      describedBy: columns.map((_col, index) => `${rowId}_cell_${indexOffset + index}`)
    })));
  }
}; // @ts-ignore

draggableColumn.Cell.displayName = 'DraggableColumnCell';
const expandableColumn = {
  id: EXPANDABLE_ID,
  width: 26,
  Cell: ({
    row
  }) => {
    return /*#__PURE__*/React.createElement(DefaultCell, {
      px: 1,
      style: _objectSpread({}, row.isExpanded ? {
        transform: 'rotate(90deg)'
      } : {}, {
        transition: 'transform 0.18s ease-out'
      })
    }, /*#__PURE__*/React.createElement(Icon, {
      type: "right",
      label: ""
    }));
  }
}; // @ts-ignore

expandableColumn.Cell.displayName = 'ExpandableColumnCell';
const selectableColumn = {
  id: SELECTABLE_ID,
  Header: ({
    rows,
    column,
    pageRows,
    isRowSelectable,
    selectAllKey
  }) => {
    var _column$getCellData;

    // If table is paginated, page contains only the visible rows
    const selectableRows = (pageRows || rows).filter(row => !isRowSelectable || isRowSelectable(row));
    const selectedRows = selectableRows.filter(row => row.isSelected);

    const _useState = useState(selectedRows.length > 0),
          _useState2 = _slicedToArray(_useState, 2),
          isChecked = _useState2[0],
          setIsChecked = _useState2[1];

    const isIndeterminate = selectedRows.length > 0 && selectedRows.length < selectableRows.length;
    useEffect(() => {
      setIsChecked(selectedRows.length > 0);
    }, [selectedRows]);

    const handleToggleAll = () => {
      const selectedValue = !isChecked;
      setIsChecked(selectedValue);
      return selectableRows.forEach(row => row.toggleRowSelected(selectedValue));
    };

    return /*#__PURE__*/React.createElement(Div, {
      display: "flex",
      alignItems: "flex-start",
      mt: "2px"
    }, /*#__PURE__*/React.createElement(Checkbox, {
      name: "toggleAll",
      onChange: handleToggleAll,
      checked: isChecked,
      indeterminate: isIndeterminate,
      disabled: !selectableRows.length || ((_column$getCellData = column.getCellData) === null || _column$getCellData === void 0 ? void 0 : _column$getCellData.call(column).disableRowSelect),
      value: "true",
      label: ""
    }), !!selectAllKey && /*#__PURE__*/React.createElement(Span, {
      ml: 3
    }, /*#__PURE__*/React.createElement(Trans, {
      id: selectAllKey
    })));
  },
  Cell: ({
    row,
    column,
    isRowSelectable
  }) => {
    var _column$getCellData2;

    const isDisabled = isRowSelectable && !isRowSelectable(row) || ((_column$getCellData2 = column.getCellData) === null || _column$getCellData2 === void 0 ? void 0 : _column$getCellData2.call(column).disableRowSelect);
    return /*#__PURE__*/React.createElement(DefaultCell, {
      alignItems: "flex-start",
      pr: 0,
      pt: 2
    }, /*#__PURE__*/React.createElement(Checkbox, _extends({
      name: "toggleRow",
      onClick: e => e.stopPropagation()
    }, row.getToggleRowSelectedProps(), isDisabled ? {
      checked: false
    } : {}, {
      // Force checked = false if disabled
      disabled: isDisabled,
      value: "true",
      label: ""
    })));
  }
}; // @ts-ignore

selectableColumn.Header.displayName = 'SelectableColumnHeader'; // @ts-ignore

selectableColumn.Cell.displayName = 'SelectableColumnCell';
const defaultColumn = {
  width: 50,
  Cell: ({
    cell: {
      value
    }
  }) => /*#__PURE__*/React.createElement(DefaultCell, null, value)
}; // @ts-ignore

defaultColumn.Cell.displayName = 'DefaultStyleColumnCell';

const defaultComponent = () => /*#__PURE__*/React.createElement(Fragment, null);

const defaultNoop = () => {};

const defaultWrapperStyle = {
  position: 'relative',
  borderBottom: `1px solid ${borderColor}`
};

const Table = (_ref2) => {
  let rowStyle = _ref2.rowStyle,
      data = _ref2.data,
      columns = _ref2.columns,
      disableHeaders = _ref2.disableHeaders,
      isLoading = _ref2.isLoading,
      hasError = _ref2.hasError,
      isEmpty = _ref2.isEmpty,
      _ref2$initialSortBy = _ref2.initialSortBy,
      initialSortBy = _ref2$initialSortBy === void 0 ? [] : _ref2$initialSortBy,
      _ref2$initialSelected = _ref2.initialSelectedRowIds,
      initialSelectedRowIds = _ref2$initialSelected === void 0 ? {} : _ref2$initialSelected,
      _ref2$renderEmpty = _ref2.renderEmpty,
      Empty = _ref2$renderEmpty === void 0 ? defaultComponent : _ref2$renderEmpty,
      _ref2$renderError = _ref2.renderError,
      Error = _ref2$renderError === void 0 ? defaultComponent : _ref2$renderError,
      _ref2$numberOfLoading = _ref2.numberOfLoadingRows,
      numberOfLoadingRows = _ref2$numberOfLoading === void 0 ? 10 : _ref2$numberOfLoading,
      expandable = _ref2.expandable,
      onlyOneExpanding = _ref2.onlyOneExpanding,
      isRowExpandable = _ref2.isRowExpandable,
      isRowSelectable = _ref2.isRowSelectable,
      _ref2$onSortBy = _ref2.onSortBy,
      onSortBy = _ref2$onSortBy === void 0 ? defaultNoop : _ref2$onSortBy,
      _ref2$onRowClick = _ref2.onRowClick,
      onRowClick = _ref2$onRowClick === void 0 ? defaultNoop : _ref2$onRowClick,
      onRowSelect = _ref2.onRowSelect,
      className = _ref2.className,
      pageSize = _ref2.pageSize,
      GlobalFilter = _ref2.GlobalFilter,
      globalFilterProps = _ref2.globalFilterProps,
      filterFunction = _ref2.filterFunction,
      bordered = _ref2.bordered,
      onRowMove = _ref2.onRowMove,
      disableRowSelect = _ref2.disableRowSelect,
      showSelectAllInHeader = _ref2.showSelectAllInHeader,
      selectedCountKey = _ref2.selectedCountKey,
      _ref2$disableSelectAl = _ref2.disableSelectAll,
      disableSelectAll = _ref2$disableSelectAl === void 0 ? false : _ref2$disableSelectAl,
      autoResetExpanded = _ref2.autoResetExpanded,
      autoResetPage = _ref2.autoResetPage,
      _ref2$selectAllKey = _ref2.selectAllKey,
      selectAllKey = _ref2$selectAllKey === void 0 ? 'common.table.select_all' : _ref2$selectAllKey,
      _ref2$clearAllKey = _ref2.clearAllKey,
      clearAllKey = _ref2$clearAllKey === void 0 ? 'common.table.clear_all' : _ref2$clearAllKey,
      _ref2$allSelectedOnPa = _ref2.allSelectedOnPageKey,
      allSelectedOnPageKey = _ref2$allSelectedOnPa === void 0 ? 'common.table.all_selected_on_page' : _ref2$allSelectedOnPa,
      _ref2$allSelectedKey = _ref2.allSelectedKey,
      allSelectedKey = _ref2$allSelectedKey === void 0 ? 'common.table.all_selected' : _ref2$allSelectedKey,
      _ref2$wrapperStyle = _ref2.wrapperStyle,
      wrapperStyle = _ref2$wrapperStyle === void 0 ? defaultWrapperStyle : _ref2$wrapperStyle,
      getRowId = _ref2.getRowId,
      wrapperProps = _objectWithoutProperties(_ref2, ["rowStyle", "data", "columns", "disableHeaders", "isLoading", "hasError", "isEmpty", "initialSortBy", "initialSelectedRowIds", "renderEmpty", "renderError", "numberOfLoadingRows", "expandable", "onlyOneExpanding", "isRowExpandable", "isRowSelectable", "onSortBy", "onRowClick", "onRowSelect", "className", "pageSize", "GlobalFilter", "globalFilterProps", "filterFunction", "bordered", "onRowMove", "disableRowSelect", "showSelectAllInHeader", "selectedCountKey", "disableSelectAll", "autoResetExpanded", "autoResetPage", "selectAllKey", "clearAllKey", "allSelectedOnPageKey", "allSelectedKey", "wrapperStyle", "getRowId"]);

  const listRef = useRef();
  const canMoveRows = !!(onRowMove && data && (data === null || data === void 0 ? void 0 : data.length) > 0);

  const _useState3 = useState(() => ++count),
        _useState4 = _slicedToArray(_useState3, 1),
        tableId = _useState4[0];

  const dragState = useMemo(() => ({
    canDrag: true
  }), []);

  const _useState5 = useState({
    disableRowSelect
  }),
        _useState6 = _slicedToArray(_useState5, 1),
        cellData = _useState6[0];

  cellData.disableRowSelect = disableRowSelect;
  const memoizedData = useMemo(() => {
    var _data;

    return isLoading ? Array.from({
      length: numberOfLoadingRows
    }, () => ({})) : [...((_data = data) !== null && _data !== void 0 ? _data : [])];
  }, [data, isLoading, numberOfLoadingRows]);

  const _useState7 = useState(memoizedData),
        _useState8 = _slicedToArray(_useState7, 2),
        reorderableData = _useState8[0],
        setReorderableData = _useState8[1];

  useEffect(() => setReorderableData(memoizedData), [memoizedData]);
  const memoizedColumns = useMemo(() => columns.map(column => _objectSpread({}, column, {
    disableSortBy: !column.enableSortBy
  })), [columns]);

  if ([GlobalFilter, filterFunction].filter(item => item).length === 1) {
    console.error('Both GlobalFilter and filterFunction must be specified together');
  }

  const cellMeasurerCache = useMemo(() => new CellMeasurerCache({
    // TODO prop
    minHeight: 37,
    fixedWidth: true
  }), []); // Use the cellMeasurer cache to determine the size of table when using
  // virtual scrolling.

  let scrollHeight = 0;

  if (onRowMove && pageSize) {
    for (let ii = 0; ii < pageSize; ++ii) {
      var _cellMeasurerCache$_r;

      // @ts-ignore
      scrollHeight += ((_cellMeasurerCache$_r = cellMeasurerCache._rowHeightCache) === null || _cellMeasurerCache$_r === void 0 ? void 0 : _cellMeasurerCache$_r[`${ii}-0`]) || 0;
    }
  }

  scrollHeight = scrollHeight || defaultScrollHeight;

  const _useTable = useTable({
    data: canMoveRows ? reorderableData : memoizedData,
    columns: memoizedColumns,
    defaultColumn,
    manualSortBy: true,
    disableMultiSort: true,
    autoResetExpanded: !!autoResetExpanded,
    autoResetPage: !!autoResetPage,
    initialState: {
      sortBy: initialSortBy,
      selectedRowIds: initialSelectedRowIds,
      pageSize
    },
    globalFilter: filterFunction,
    // @ts-ignore
    getRowId
  }, useFlexLayout, ...(GlobalFilter ? [useGlobalFilter] : []), useSortBy, useExpanded, useRowSelect, ...(pageSize ? [usePagination] : []), hooks => {
    if (onRowSelect) {
      hooks.visibleColumns.push(columns => [_objectSpread({}, selectableColumn, {
        width: showSelectAllInHeader ? 120 : 34,
        isRowSelectable,
        getCellData: () => cellData
      }), ...columns]);
    }

    if (canMoveRows) {
      hooks.visibleColumns.push(columns => [_objectSpread({}, draggableColumn, {
        isDragHandleVisible: () => dragState.canDrag,
        getTableId: () => tableId,
        moveRow: (rowsToUpdate, {
          newIndex,
          oldIndex
        }) => {
          const updatedData = arrayMove(rowsToUpdate.map(row => row.original), oldIndex, newIndex);
          setReorderableData(updatedData);
          onRowMove === null || onRowMove === void 0 ? void 0 : onRowMove(updatedData, {
            newIndex,
            oldIndex
          });
        }
      }), ...columns]);
    }

    if (expandable) {
      hooks.visibleColumns.push(columns => [expandableColumn, ...columns]);
    }
  }),
        getTableProps = _useTable.getTableProps,
        getTableBodyProps = _useTable.getTableBodyProps,
        gotoPage = _useTable.gotoPage,
        headerGroups = _useTable.headerGroups,
        rows = _useTable.rows,
        page = _useTable.page,
        prepareRow = _useTable.prepareRow,
        _useTable$state = _useTable.state,
        sortBy = _useTable$state.sortBy,
        selectedRowIds = _useTable$state.selectedRowIds,
        pageIndex = _useTable$state.pageIndex,
        globalFilter = _useTable$state.globalFilter,
        canPreviousPage = _useTable.canPreviousPage,
        canNextPage = _useTable.canNextPage,
        previousPage = _useTable.previousPage,
        nextPage = _useTable.nextPage,
        preGlobalFilteredRows = _useTable.preGlobalFilteredRows,
        _setGlobalFilter = _useTable.setGlobalFilter,
        toggleAllRowsSelected = _useTable.toggleAllRowsSelected,
        toggleAllRowsExpanded = _useTable.toggleAllRowsExpanded;

  useEffect(() => {
    if (!onRowSelect || isLoading) return;
    const rowObjects = Object.keys(selectedRowIds).reduce((acc, rId) => {
      const rawRow = (preGlobalFilteredRows || rows).find(({
        id
      }) => rId === id);
      if (!rawRow) return acc;
      if (isRowSelectable && !isRowSelectable(rawRow)) return acc;
      return [...acc, _objectSpread({
        rowIndex: rawRow.index
      }, rawRow.original)];
    }, []);
    onRowSelect(rowObjects);
  }, [selectedRowIds, isLoading]);
  useEffect(() => {
    onSortBy(sortBy);
  }, [sortBy]);
  useEffect(() => {
    cellMeasurerCache === null || cellMeasurerCache === void 0 ? void 0 : cellMeasurerCache.clearAll();
  }, [columns, data]);

  const _useMeasure = useMeasure({
    polyfill: ResizeObserver
  }),
        _useMeasure2 = _slicedToArray(_useMeasure, 2),
        ref = _useMeasure2[0],
        containerWidth = _useMeasure2[1].width;

  const selectedRowsCount = Object.keys(selectedRowIds).length;
  const allSelected = selectedRowsCount === rows.length;
  const pageSelected = !!pageSize && page.every(row => row.isSelected);
  const filtered = !!preGlobalFilteredRows && preGlobalFilteredRows.length !== rows.length;
  const showSelectAll = !!selectedRowsCount && pageSelected;
  return /*#__PURE__*/React.createElement(Div, wrapperProps, !!GlobalFilter && /*#__PURE__*/React.createElement(GlobalFilter, _extends({
    rows: rows,
    preGlobalFilteredRows: preGlobalFilteredRows,
    globalFilter: globalFilter,
    selectedRowsCount: selectedRowsCount,
    toggleAllRowsSelected: toggleAllRowsSelected,
    setGlobalFilter: filter => {
      dragState.canDrag = !filter;

      if (!!pageSize) {
        gotoPage(0);
      }

      _setGlobalFilter(filter);
    }
  }, globalFilterProps || {})), /*#__PURE__*/React.createElement("div", {
    ref: ref,
    className: className,
    style: _objectSpread({}, bordered ? {
      border: `1px solid ${borderColor}`
    } : {}, wrapperStyle)
  }, /*#__PURE__*/React.createElement(Div, getTableProps(), /*#__PURE__*/React.createElement(HeaderRow, {
    disableHeaders: disableHeaders,
    headerGroups: headerGroups,
    isLoading: isLoading,
    isEmpty: isEmpty,
    hasError: hasError,
    selectAllKey: showSelectAllInHeader ? selectAllKey : undefined
  }), (showSelectAll || selectedCountKey) && !disableRowSelect && !disableSelectAll && /*#__PURE__*/React.createElement(Div, {
    backgroundColor: "gray.9",
    textAlign: "center",
    padding: 2,
    borderRadius: 2,
    borderBottom: "1px solid",
    borderColor: borderColor
  }, /*#__PURE__*/React.createElement(Trans, {
    id: selectedCountKey || (allSelected ? allSelectedKey : allSelectedOnPageKey),
    smartCount: !selectedCountKey && pageSize && !allSelected ? page.filter(row => row.isSelected).length : selectedRowsCount
  }), /*#__PURE__*/React.createElement(Link, {
    pl: 3,
    onClick: e => {
      e.preventDefault();
      toggleAllRowsSelected(!allSelected);
    }
  }, /*#__PURE__*/React.createElement(Trans, {
    id: allSelected ? clearAllKey : selectAllKey
  }))), /*#__PURE__*/React.createElement(Div, getTableBodyProps(), (!isLoading && isEmpty || filtered && !rows.length) && /*#__PURE__*/React.createElement(Empty, {
    globalFilter: globalFilter
  }), !isLoading && hasError && /*#__PURE__*/React.createElement(Error, null), (!isEmpty || !hasError) && (!filtered && canMoveRows ? /*#__PURE__*/React.createElement(ScrollWrapper, {
    style: {
      height: scrollHeight + 'px'
    }
  }, /*#__PURE__*/React.createElement(AutoSizer, null, ({
    width
  }) => /*#__PURE__*/React.createElement(SortableList, {
    ref: listRef,
    deferredMeasurementCache: cellMeasurerCache,
    rowHeight: cellMeasurerCache.rowHeight,
    height: scrollHeight,
    rowCount: rows.length,
    width: width,
    rowRenderer: ({
      index,
      style,
      parent
    }) => {
      var _row$getRowProps2;

      const row = rows[index];
      prepareRow(row); // Use row.original.id as key instead of row.getRowProps()?.key to fix the bug causing by index shiftting
      // ex: row.original.id => 911874bcebe89ca25c0d9e415de7f634, row.getRowProps()?.key => row_0

      const rowId = `table_${tableId}_row${row.original.id || ((_row$getRowProps2 = row.getRowProps()) === null || _row$getRowProps2 === void 0 ? void 0 : _row$getRowProps2.key)}`;
      return /*#__PURE__*/React.createElement(CellMeasurer, {
        cache: cellMeasurerCache,
        columnIndex: 0,
        key: `sortable-row-${rowId}`,
        parent: parent,
        rowIndex: index
      }, /*#__PURE__*/React.createElement(SortableRow, {
        row: row,
        rowId: rowId,
        index: index,
        rowIndex: index,
        style: style,
        rowStyle: _objectSpread({}, rowStyle, style),
        isLoading: isLoading,
        striped: false,
        rowHighlight: false,
        onRowClick: onRowClick,
        containerWidth: containerWidth,
        disabled: isRowSelectable && !isRowSelectable(row) || disableRowSelect
      }));
    },
    lockAxis: "y",
    helperClass: "cf-table-row-drag",
    useDragHandle: true,
    onSortEnd: ({
      newIndex,
      oldIndex
    }) => {
      cellMeasurerCache.clearAll();
      const updatedData = arrayMove(reorderableData, oldIndex, newIndex);
      setReorderableData(updatedData);
      onRowMove === null || onRowMove === void 0 ? void 0 : onRowMove(updatedData, {
        newIndex,
        oldIndex
      });
    }
  }))) : (page || rows).map((row, i) => {
    var _row$getRowProps3;

    prepareRow(row); // Use row.original.id as key instead of row.getRowProps()?.key to fix the bug causing by index shiftting
    // ex: row.original.id => 911874bcebe89ca25c0d9e415de7f634, row.getRowProps()?.key => row_0

    const rowId = `table_${tableId}_row${row.original.id || ((_row$getRowProps3 = row.getRowProps()) === null || _row$getRowProps3 === void 0 ? void 0 : _row$getRowProps3.key)}`;
    return /*#__PURE__*/React.createElement(Row, {
      key: rowId,
      testId: `row_${row.original.id}`,
      row: row,
      rowIndex: i,
      rowId: rowId,
      rowStyle: rowStyle,
      expandable: expandable,
      isRowExpandable: isRowExpandable,
      isRowSelectable: isRowSelectable,
      onlyOneExpanding: onlyOneExpanding,
      toggleAllRowsExpanded: toggleAllRowsExpanded,
      isLoading: isLoading,
      striped: false,
      rowHighlight: false,
      onRowClick: onRowClick,
      containerWidth: containerWidth,
      disabled: isRowSelectable && !isRowSelectable(row)
    });
  })))), !onRowMove && !!pageSize && rows.length > pageSize && /*#__PURE__*/React.createElement(Div, {
    borderTop: bordered ? 'none' : '1px solid',
    borderColor: borderColor
  }, /*#__PURE__*/React.createElement(Pagination, {
    p: 2,
    loading: isLoading,
    start: pageIndex * pageSize + 1,
    end: Math.min(pageIndex * pageSize + pageSize, rows.length),
    total: rows.length,
    onPrevClick: previousPage,
    onNextClick: nextPage,
    disablePreviousButton: !canPreviousPage,
    disableNextButton: !canNextPage
  }))));
};

export default Table;